
import java.util.Scanner;
/**
 * Created by leon on 2/9/18.
 */
public class Console {

    public static void main(String[] args) {
        double answer;
        // Create all instances of classes to be used for this program
        MainMenu mainMenu = new MainMenu();
        Basic basicCalc = new Basic();
        SciCalc scientificCalc = new SciCalc();
        MemoryFunc memory = new MemoryFunc();
        SwitchDisplay baseChange = new SwitchDisplay();
        Trig trigMenu = new Trig();

        // Stored memory value should be able to be used throughout whole application
        Double memoryValue = memory.memory;

        // blanket input statement 
        // create input methods to call when we need them with specific types
        // we use 1 input variable statement to call the user to input, then manipulate
        // Can user input M if native type is double
        // if any input = "m", that input now = memoryValue;

        // Menu Input
        String menuInput = " ";
        // Giant while loop that links back to main menu
        while (!menuInput.equals("4")) {
            mainMenu.mainMenuDisplay();
            menuInput = Console.getStringInput("Enter the calculator you want to use by key. (ie. 1 for basic, etc.)");

            switch (menuInput) {
                // Basic Calculator
                case "1":
                basicCalc.Basic();

                double basicInput1 = Console.getIntegerInput("Enter the first input: ");

                String basicMode = Console.getStringInput("Enter the mode: ");

                double basicInput2 = Console.getIntegerInput("Enter the second input: ");

                if (basicMode.equals("+")) {
                    basicCalc.getSum(basicInput1, basicInput2);

                    //subtraction    
                } else if (basicMode.equals("-")) {
                    basicCalc.getDiff(basicInput1, basicInput2);

                    //multiplication
                } else if (basicMode.equals("*")) {
                    basicCalc.getProduct(basicInput1, basicInput2);

                    //division    
                } else if (basicMode.equals("/")) {
                    //error message when trying to divide by 0.
                    if (basicInput2 == 0) {
                        Console.println("undefined");
                        //Insert return to main menu.
                    } else {
                        basicCalc.getQuotient(basicInput1, basicInput2);
                    }
                } else if (basicMode.equals("5")) {

                    break;

                } else {
                    //error if wrong input was entered
                    answer = Double.NaN;
                    Console.println("Invalid Input");
                }

                break;
                case "2":
                // Sends to Advanced Calculator Functions
                break;

                case "3":

                // Sends to Scientific Calculator Functions
                // displays the menu for scientific calc
                scientificCalc.toSciMenu();
                String sciMenuInput = Console.getStringInput("Enter the function you'd like to use by key.");
                // if statement to use various calc functions
                if (sciMenuInput.equals("1")) {
                    // Base Conversions
                    // while loop for display 
                    String mode = "";
                    while (!mode.equals("Invalid Input")) {
                        baseChange.switchDisplay(); 
                        mode = Console.getStringInput("Enter the desired display mode: ");
                    }

                    int userInput = getIntegerInput("Enter the number you want to convert to selected base: ");
                    baseChange.switchDisplayOutput(mode, userInput);

                    // display mode
                    // gets mode
                    // asks for input
                } else if (sciMenuInput.equals("2")) {
                    // Memory
                    memory.memoryMenu();
                } else if (sciMenuInput.equals("3")) {
                    // To Trig Menu
                    trigMenu.trigFunctions();
                    String mode = Console.getStringInput("Enter trignometric function by key: (ie. 1 for sin)");

                    double trigInput = Console.getDoubleInput("Enter the input for the trignometric function: ");

                    if (mode.equals("1")) {
                        answer = trigMenu.calcSin(trigInput);

                        //COS
                    } else if (mode.equals("2")) {
                        answer = trigMenu.calcCos(trigInput);

                        //TAN
                    } else if (mode.equals("3")) {
                        answer = trigMenu.calcTan(trigInput);

                        //ARCSIN
                    } else if (mode.equals("4")) {
                        answer = trigMenu.calcArcsin(trigInput);

                        //ARCCOS
                    } else if (mode.equals("5")) {
                        answer = trigMenu.calcArccos(trigInput);

                        //ARCTAN
                    } else if (mode.equals("6")) {
                        answer = trigMenu.calcArctan(trigInput);

                    } else if (mode.equals("7")) {
                        break;

                    } else {
                        //Error message if input does not match options, loops back to the top so they can try again.
                        answer = Double.NaN;

                    }

                    String trigAnswer = Double.toString(answer);
                    Console.println(trigAnswer);

                    String trigDefRad =  Console.getStringInput("Do you want to convert your answer from radians to degrees?"
                            + "\nEnter Y or N").toLowerCase();

                    if (trigDefRad.equals("y") ) {
                        trigMenu.toDegrees(answer);
                    }
                    break;
                } else {
                    break;
                }
                break;

                case "4":
                // Quits the calculator
                break;
            }

        }
    }

    public static void print(String output, Object... args) {
        System.out.printf(output, args);
    }

    public static void println(String output, Object... args) {
        print(output + "\n", args);
    }

    public static String getStringInput(String prompt) {
        Scanner scanner = new Scanner(System.in);
        println(prompt);
        String userInput = scanner.nextLine();
        return userInput;
    }

    public static Integer getIntegerInput(String prompt) {
        Scanner scanner = new Scanner(System.in);
        println(prompt);
        Integer userInput = scanner.nextInt();
        return userInput;
    }

    public static Double getDoubleInput(String prompt) {
        Scanner scanner = new Scanner(System.in);
        println(prompt);
        Double userInput = scanner.nextDouble();
        return userInput;
    }
}
